!> \file climat-profil_mod-0.4.f90
!! module pour creer une calotte a partir d'un masque (mk0)
!<

!> \namespace CLIMAT_PROFIL_MOD
!! Module pour creer une calotte a partir d'un masque (mk0)
!! \author Vincent Peyaud
!! \date  fevrier 2006
!! @note Ex profil calotte saalian pour Gerard
!! @note Used module
!! @note   - use module3D_phy
!! @note   - use printtable
!<
MODULE  CLIMAT_PROFIL_MOD
!Vincent Peyaud fevrier 2006
!module pour creer une calotte a partir d'un masque (mk0)
!Ex profil calotte saalian pour Gerard
!!!!!!!!!!!!!!!!!!!!=1=decalaration variables================!!!!!!!!!!!!!!!!!!!!

       use module3D_phy
       use printtable
implicit none
CHARACTER(LEN=80) :: filin
INTEGER NFT!   NFT est le nombre de lignes a lire dans le fichier 
           ! contenant le forcage climatique
REAL,dimension(:),allocatable :: TDATE          ! time for climate forcing
REAL,dimension(:),allocatable :: alphaT
REAL,dimension(:),allocatable :: alphaP
REAL,dimension(:),allocatable :: SPERT
INTEGER,parameter :: NTR=1 ! nb of snapshot files
!ntr is now explicitely specified in the climat module
CHARACTER(LEN=80) masque_ice
!CHARACTER(LEN=80),dimension(ntr)::  filtr   !snapshot file name (len=ntr) 
REAL ttr(2)! la date des tranches (snapshots)  (len=ntr) 
REAL delTa(nx,ny,ntr),delTj(nx,ny,ntr),rapact(nx,ny,ntr)
REAL  delTatime(nx,ny),delTjtime(nx,ny),rapactime(nx,ny)

CONTAINS
!!!!!!!!!!!!!!!!!!!!=2=lecure des input=s====================!!!!!!!!!!!!!!!!!!!!
!> SUBROUTINE: input_clim
!! Routine qui permet d'initialiser les variables climatiques
!>
subroutine INPUT_CLIM !routine qui permet d'initialiser les variables climatiques
       USE module3D_phy

  implicit none
CHARACTER(LEN=8) :: control!label to check clim. forc. file (filin) is usable
INTEGER L !In snapshot files:the first column is the mask, read but not used
INTEGER iii,jjj 
if (geoplace.eq.'euras40') then
        TEMPGRAD=0.008
        TEMPGRJUL=0.0065
        masque_ice=TRIM(DIRNAMEINP)//'masque_saalian_eurasie40.dat'
        filin=TRIM(DIRNAMEINP)//'signal-cycle-hemin.dat'
        elseif (geoplace.eq.'heminor') then
!     atmospheric temperature gradient
        TEMPGRAD=0.008
        TEMPGRJUL=0.0065
!Pou le nord cette pariti est copie de inputfile-hemicycle.f (3juin04)
! 1_fichiers snapshots pour forcage
!----------------------------------
!          filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcLGM-lmd5prese.g50'
!          filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forcLGM-lmd5futur.g50'
! 2_fichiers donnant l'evolution temporelle
! -------------------HEMICYCLE ------------
! lecture du fichier scalaire (sea level)
!        filin=TRIM(DIRNAMEINP)//'heminor-forcLGM.dat'
         filin=TRIM(DIRNAMEINP)//'signal-cycle-hemin.dat'
!!!this file contains TDATE(I),alphaT(I),alphaP(i),SPERT(I),I=1,nft         
elseif (geoplace.eq.'hemin40') then
!     atmospheric temperature gradient
        TEMPGRAD=0.008
        TEMPGRJUL=0.0065
        masque_ice=TRIM(DIRNAMEINP)//'masque_saalian_hemin40.dat'
! 1_fichiers snapshots pour forcage
!----------------------------------
!          filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/file_regions_2.g40'
!          filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/file_regions_2act.g40'
! 2_fichiers donnant l'evolution temporelle
! -----------------------------------------
        filin=TRIM(DIRNAMEINP)//'signal-cycle-hemin.dat'
elseif ((geoplace.eq.'anteis1').or.(geoplace.eq.'ant20km')) then
!     atmospheric temperature gradient
        TEMPGRAD=0.0085
        TEMPGRJUL=0.0085
! 1_fichiers snapshots pour forcage
!----------------------------------
!           filtr(1)='../INPUT-DATA/FORCAGES/forcage-ant-20k.g40'
!           filtr(2)='../INPUT-DATA/FORCAGES/forcage-ant-00k.g40'
! 2_fichiers donnant l'evolution temporelle
! ---------------------------- ------------
         filin=TRIM(DIRNAMEINP)//'forcmodif4cycles.dat' !forcage vostok en rapport : a creer

endif !Fin du test sur geolpace

! 3_lecure des fichiers snapsots pour tout geoplace
! -------------------------------------------------
write(6,*) 'fichiers masque'
!        do k=1,ntr
         write(6,*) masque_ice
         open(num_forc,file=masque_ice)
         read(num_forc,*) 
         read(num_forc,*)
         read(num_forc,*)
           do j=1,ny
            do i=1,nx
              read(num_forc,*) iii,jjj,mk0(i,j)
!             read(num_forc,*) mk0(i,j)
            end do
           end do
         close(num_forc)
!         end DO
      do j=3,ny-2
         do i=3,nx-2
            mk0(i,j)=1
            if ((i.lt.25).and.(j.gt.35)) mk0(i,j)=0
         end do
      end do
                                                         
        ttr(1)=-500000. !ttr est la date des tranches 3D-1.h
        ttr(2)=0
! 4_lecure des fichiers d'evolution pour tout geoplace
! ----------------------------------------------------
         open(num_forc,file=filin,status='old')
!        print*,nft
         read(num_forc,*) control,nft
        print*,'control',control,nft
! Determination of file size (line nb), allocation of perturbation array
if (control.ne.'nb_lines') then
         write(6,*) filin,'indiquer le nb de ligne en debut de fichier:'
         write(6,*) 'le nb de lignes et le label de control nb_lines'
         stop
endif
    if (.not.allocated(TDATE)) THEN
       allocate(TDATE(nft),stat=err)
         if (err/=0) then
           print *,"Erreur  l'allocation du tableau TDATE",err
           stop 4
         end if
    end if
    if (.not.allocated(alphaT)) THEN
       allocate(alphaT(nft),stat=err)
         if (err/=0) then
           print *,"Erreur  l'allocation du tableau TPERT",err
           stop 4
         end if
    end if
    if (.not.allocated(alphaP)) THEN
       allocate(alphaP(nft),stat=err)
         if (err/=0) then
           print *,"Erreur  l'allocation du tableau TPERT",err
           stop 4
         end if
    end if
    if (.not.allocated(SPERT)) THEN
       allocate(SPERT(nft),stat=err)
         if (err/=0) then
           print *,"Erreur  l'allocation du tableau SPERT",err
           stop 4
         end if
    end if
        
         do I=1,NFT
           read(num_forc,*) TDATE(I),alphaT(I),alphaP(i),SPERT(I)
!          print*,TDATE(I),alphaT(I),alphaP(i),SPERT(I)
         end do
!          do j=1,ny
!           do i=1,nx
!             h(i,j)=250.*mk0(i,j) 
!             end do
!          end do
print*, 'module profil  climatique'
!nom_table='mk0'
!call printtable_i(mk0,nom_table)
! A CREER ou organiser a partir des codes dans ! 2_fichiers donnant l'evolution temporelle

END subroutine INPUT_CLIM

!!!!!!!!!!!!!!!!!!!!=3=forcage climatique====================!!!!!!!!!!!!!!!!!!!!
!> SUBROUTINE: forclim
!! Routine qui permet le calcule climatiques au cours du temps
!>
subroutine FORCLIM
       USE module3D_phy
  implicit none
  real COEFT,COEFP,coeftime!coeftime is not used
  INTEGER L !dumm index for loops on snapsots files  l=ITR,NTR-1
  INTEGER ITR !nb of the current snapshot file (change with time)
!       TIME en dehors des limites du fichier forcage
!       if(TIME.le.TDATE(1)) then
!         TAFOR=TPERT(1)
!         SEALEVEL=SPERT(1)
!         COEFT=alphaT(1)
!         COEFP=alphaP(1)
!         IFT=1
!       else if (TIME.ge.TDATE(NFT)) then
!         TAFOR=TPERT(NFT)
!         SEALEVEL=SPERT(NFT)
!         COEFT=alphaT(NFT)
!         COEFP=alphaP(NFT)
!         IFT=NFT
!       ELSE

!A modifier
!        IFT = 1      ! modifie par SC le 24/11/99
!       do I=IFT,NFT-1
!       print*,'ds boucle1 sur snapshots',ift,TDATE(I),TDATE(I+1),time 
!         if((TIME.ge.TDATE(I)).and.(TIME.lt.TDATE(I+1))) then
!        interpolation entre I et I+1 : cas general
!           TAFOR=TPERT(I)+(TPERT(I+1)-TPERT(I))*
!    &            (TIME-TDATE(I))/(TDATE(I+1)-TDATE(I))
!         SEALEVEL=SPERT(I)+(SPERT(I+1)-SPERT(I))*    &
!                (TIME-TDATE(I))/(TDATE(I+1)-TDATE(I))

!         COEFT=alphaT(I)+(alphaT(I+1)-alphaT(I))*      &
!                (TIME-TDATE(I))/(TDATE(I+1)-TDATE(I))

!         COEFP=alphaP(I)+(alphaP(I+1)-alphaP(I))*      &
!                (TIME-TDATE(I))/(TDATE(I+1)-TDATE(I))
!        SEALEVEL=-50.         
!       print*,'SEA,COEFT,COEFP', SEALEVEL,COEFT,COEFP
!           IFT=I
!           goto 100
!         endif

!       end do
!     endif
!100   continue

!          print*,'coeffT P',COEFT,COEFP
!=forcage du climat
!       TIME en dehors des limites du fichier forcage
!        if(TIME.le.Ttr(1)) then   ! mis a -500 000 ans
!          do j=1,ny
!            do i=1,nx
!              delTatime(i,j)=delTa(i,j,1)
!              delTjtime(i,j)=delTj(i,j,1)
!              rapactime(i,j)=rapact(i,j,1)
!            end do
!           end do
!              ITR=1

!        else if (TIME.ge.ttr(Ntr)) then        ! mis a 0
!          do j=1,ny
!            do i=1,nx
!             delTatime(i,j)=delTa(i,j,ntr)
!             delTjtime(i,j)=delTj(i,j,ntr)
!             rapactime(i,j)=rapact(i,j,ntr)
!            end do
!           end do
!           ITR=NTR

!        else               !  interpolation entre l et l+1 : cas general
!        itr=max(itr,1)
!       WRITE(6,*)'itr = !',itr


!parametres du fit

!        do l=ITR,NTR-1
!        print*,'ds boucle2 sur snapshots',l,ttr(l) 
!           if((TIME.ge.ttr(l)).and.(TIME.lt.ttr(l+1))) then  ! test tranche
!
!           coeftime= (TIME-TTR(l))/(TTR(l+1)-TTR(l))
!           do j=1,ny
!            do i=1,nx
!            delTatime(i,j)=delTa(i,j,l)+             &
!               (delTa(i,j,l+1)-delTa(i,j,l))*coefT

!            delTjtime(i,j)=delTj(i,j,l)+             &
!               (delTj(i,j,l+1)-delTj(i,j,l))*coefT

!            rapactime(i,j)=rapact(i,j,l)+            &
!               (rapact(i,j,l+1)-rapact(i,j,l))*coefP
!             end do
!           end do
!           ITR=l
!            goto 200
!
!            endif        ! fin du test sur la tranche
!         end do
!       endif   ! fin du test avant,apres,milieu
!
200   continue
!     sortie pour verifier les valeurs
!      print*,time ,coefT,coefP,sealevel
!0print*,'dans le forclim climat coefbmshelf nest pas defini'
!! coefmshelf est un coefficient qui fait vairier bmgrz et bmshelf
!! en fonction de TAFOR (deplace depuis icetemp 16juin2004(au LSCE))
!! coefbmshelf=(1.+TAFOR/10.)    ! coefbmshelf=0 pour TAFOR=-10deg
!           do j=60,120!1,ny
!            do i=50,100 !1,nx
!                 if ((flot(i,j).and.time.lt.130000).and.  &
!                     .not.(i.gt.75.and.j.lt.75)) then
!                   delTjtime(i,j)=delTjtime(i,j)-4.
!                   delTatime(i,j)=delTatime(i,j)-4.
!                endif
!             end do
!           end do

!   delTatime=-5.
!   delTjtime=-5. 
    rapactime=1.2
    do j=1,ny  
    do i=1,nx    
    if (j.le.20) delTatime(i,j)=-14.
    if (j.le.20) delTjtime(i,j)=-14.
    if (j.gt.128) delTatime(i,j)=-7.
    if (j.gt.128) delTjtime(i,j)=-7.
    enddo
    enddo 
!   do j=1,ny  
!   do i=1,nx    
    do j=20,128!20,ny  
!   delTatime(i,j)=-14+7.*(  (j-20) )/115.
!   delTjtime(i,j)=-14+7.*(  (j-20) )/115.
    do i=1,nx!25,nx!20,nx    
!  delTatime(i,j)=-18+7.*(((i*i-120*120)+(j*j-21*21))**0.5)/170.
!  delTatime(i,j)=-18+7.*((i*i)**0.5+(j*j)**0.5)/170.
!  delTatime(i,j)=-18+8.*( ( (i-25)*(i-25) )**0.5+ ( (j*j)-200 )**0.5)/170.
   delTatime(i,j)=-17+9.*(  (j-20) )/115.
   delTjtime(i,j)=-17+9.*(  (j-20) )/115.
    enddo
    enddo 
    do j=1,ny  
    do i=1,nx    
!     if ((S0(i,j).eq.0.).and.(S(i,j).gt.sealevel)) then
!           if (j.lt.55.and.i.gt.35) then
!           else        
!           delTjtime(i,j)=delTjtime(i,j)+5
!           endif
!     endif
!  if (ice(i,j)==1) delTjtime(i,j)=delTjtime(i,j)-3.
    enddo
    enddo 

    sealevel=-55.
!    TAFOR=delTatime(90,100)
! coefbmshelf=(1.+TAFOR/7.)    ! coefbmshelf=0 pour TAFOR=-7deg standard
!   coefbmshelf(:,:)=(1.+delTatime(:,:)/7.)  
 coefbmshelf=1. ! modif pour test de sensibilite (tof 20 avril 01)
   coefbmshelf=max(coefbmshelf,0.)
   coefbmshelf=min(coefbmshelf,2.)
print*,'= t,sea,tafor',time,sealevel,tafor
print*,'coefbmshelf',coefbmshelf

if ((geoplace(1:5).eq.'hemin').or.(geoplace(1:5).eq.'euras')) then
call ACCUM7() ! ds le main
call ablation()

!open(unit=15,file='forcage_eur.dat')
!do j=1,ny
!do i=1,nx
!write(15,*) delTjtime(i,j),delTjtime(i,j),rapactime(i,j)
!enddo
!enddo
!close(15)

elseif ((geoplace.eq.'anteis1').or.(geoplace.eq.'ant20km')) then
! call n'est plus dans le main
call MASSB_ANTEIS_FORCAGE()
call ABLATION()
else
 print*,"partie en travaux climat forcage auter que sur heminord"
 print*,"geoplace ",geoplace
endif

!
!!          Tjuly(i,j)=min(Tjuly(i,j),-3.0)
!!          TANN(I,J)=min(TANN(I,J),Tjuly(i,j))
!nom_table='surf'
!call printtable_r(S0,nom_table)
!nom_table='ta0'
!call printtable_r(ta0,nom_table)
!nom_table='tann'
!call printtable_r(tann,nom_table)
!nom_table='tj0'
!call printtable_r(tj0,nom_table)
!nom_table='tjja'
!call printtable_r(tjuly,nom_table)
!nom_table='dta_'
!call printtable_r(delTatime,nom_table)
!nom_table='pre0'
!call printtable_r(precip0,nom_table)
!nom_table='prec'
!call printtable_r(precip,nom_table)
!nom_table='surf'
! call printtable_r(s,nom_table)

END subroutine FORCLIM

END MODULE  CLIMAT_PROFIL_MOD
